package com.ruoyi.system.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.ruoyi.common.core.domain.entity.RlUser;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.system.mapper.RlUserMapper;
import com.ruoyi.system.service.IRlUserService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import javax.validation.Validator;
import java.util.List;

/**
 * 用户 业务层处理
 *
 * @author ruoyi
 */
@Slf4j
@Service
public class RlUserServiceImpl implements IRlUserService{

    @Resource
    private RlUserMapper rlUserMapper;

    @Autowired
    protected Validator validator;

//    @Autowired
//    private IEtOrderService etOrderService;
//
//    @Autowired
//    private IEtOperatingAreaService etOperatingAreaService;
//
//    @Autowired
//    private RedisCache redisCache;
//
//    @Resource
//    private EtOrderMapper etOrderMapper;

//    @Resource
//    private SysUserMapper userMapper;

//    @Value("${et.verifyUrl}")
//    private String verifyUrl;
//
//    @Value("${et.appcode}")
//    private String appcode;

    /**
     * 根据条件分页查询用户列表
     *
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    @Override
    public List<RlUser> selectUserList(RlUser user)
    {
        /** 获取设备绑定数量*/
        List<RlUser> users = rlUserMapper.selectUserList(user);
//        for(EUser u:users){
//            EtOrder etOrder  = new EtOrder();
//            etOrder.setUserId(u.getUserId());
//            EtOrder order = etOrderService.latestOrder(etOrder);
//            if(ObjectUtil.isNotNull(order)){
//                EtOrderDto etOrderVo = new EtOrderDto();
//                BeanUtils.copyBeanProp(etOrderVo,order);
//                u.setLatestOrder(etOrderVo);
//            }
//            if(ObjectUtil.isNotNull(u.getSysUserId())){
//                Long sysUserId = u.getSysUserId();
//                SysUser sysUser = userMapper.selectUserById(sysUserId);
//                u.setSysUser(sysUser);
//            }
//        }
        return users;
    }

//    /**
//     * 根据条件分页查询已分配用户角色列表
//     *
//     * @param user 用户信息
//     * @return 用户信息集合信息
//     */
//    @Override
//    @DataScope(deptAlias = "d", userAlias = "u")
//    public List<EUser> selectAllocatedList(EUser user)
//    {
//        return EUserMapper.selectAllocatedList(user);
//    }
//
//    /**
//     * 根据条件分页查询未分配用户角色列表
//     *
//     * @param user 用户信息
//     * @return 用户信息集合信息
//     */
//    @Override
//    @DataScope(deptAlias = "d", userAlias = "u")
//    public List<EUser> selectUnallocatedList(EUser user)
//    {
//        return EUserMapper.selectUnallocatedList(user);
//    }
//
//    /**
//     * 通过用户名查询用户
//     *
//     * @param userName 用户名
//     * @return 用户对象信息
//     */
//    @Override
//    public EUser selectUserByUserName(String userName)
//    {
//        return EUserMapper.selectUserByUserName(userName);
//    }

    /**
     * 通过用户ID查询用户
     *
     * @param userId 用户ID
     * @return 用户对象信息
     */
    @Override
    public RlUser selectUserById(Long userId)
    {
        RlUser users = rlUserMapper.selectUserById(userId);
        if(ObjectUtil.isNull(users)){
            throw new ServiceException("没有该用户："+userId);
        }
        return users;
    }


//    /**
//     * 校验用户名称是否唯一
//     *
//     * @param user 用户信息
//     * @return 结果
//     */
//    @Override
//    public boolean checkUserNameUnique(EUser user)
//    {
//        Long userId = StringUtils.isNull(user.getUserId()) ? -1L : user.getUserId();
//        EUser info = EUserMapper.checkUserNameUnique(user.getUserName());
//        if (StringUtils.isNotNull(info) && info.getUserId().longValue() != userId.longValue())
//        {
//            return UserConstants.NOT_UNIQUE;
//        }
//        return UserConstants.UNIQUE;
//    }
//
//    /**
//     * 校验手机号码是否唯一
//     *
//     * @param user 用户信息
//     * @return
//     */
//    @Override
//    public boolean checkPhoneUnique(EUser user)
//    {
//        Long userId = StringUtils.isNull(user.getUserId()) ? -1L : user.getUserId();
//        EUser info = EUserMapper.checkPhoneUnique(user.getPhonenumber());
//        if (StringUtils.isNotNull(info) && info.getUserId().longValue() != userId.longValue())
//        {
//            return UserConstants.NOT_UNIQUE;
//        }
//        return UserConstants.UNIQUE;
//    }
//
//    /**
//     * 校验email是否唯一
//     *
//     * @param user 用户信息
//     * @return
//     */
//    @Override
//    public boolean checkEmailUnique(EUser user)
//    {
//        Long userId = StringUtils.isNull(user.getUserId()) ? -1L : user.getUserId();
//        EUser info = EUserMapper.checkEmailUnique(user.getEmail());
//        if (StringUtils.isNotNull(info) && info.getUserId().longValue() != userId.longValue())
//        {
//            return UserConstants.NOT_UNIQUE;
//        }
//        return UserConstants.UNIQUE;
//    }
//
//
    /**
     * 新增保存用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    @Transactional
    public int insertUser(RlUser user)
    {
        return rlUserMapper.insertUser(user);
    }
//
//    /**
//     * 注册用户信息
//     *
//     * @param user 用户信息
//     * @return 结果
//     */
//    @Override
//    public boolean registerUser(EUser user)
//    {
//        return EUserMapper.insertUser(user) > 0;
//    }
//
    /**
     * 修改保存用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    @Transactional
    public int updateUser(RlUser user)
    {
        Long userId = user.getUserId();
        return rlUserMapper.updateUser(user);
    }


    /**
     * 修改用户状态
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public int updateUserStatus(RlUser user)
    {
        return rlUserMapper.updateUser(user);
    }

    /**
     * 修改用户基本信息
     *
     * @param user 用户信息
     * @return 结果
     */
    @Override
    public int updateUserProfile(RlUser user)
    {
        return rlUserMapper.updateUser(user);
    }
//
//    /**
//     * 修改用户头像
//     *
//     * @param userName 用户名
//     * @param avatar 头像地址
//     * @return 结果
//     */
//    @Override
//    public boolean updateUserAvatar(String userName, String avatar)
//    {
//        return EUserMapper.updateUserAvatar(userName, avatar) > 0;
//    }
//
//    /**
//     * 重置用户密码
//     *
//     * @param user 用户信息
//     * @return 结果
//     */
//    @Override
//    public int resetPwd(EUser user)
//    {
//        return EUserMapper.updateUser(user);
//    }
//
//    /**
//     * 重置用户密码
//     *
//     * @param userName 用户名
//     * @param password 密码
//     * @return 结果
//     */
//    @Override
//    public int resetUserPwd(String userName, String password)
//    {
//        return EUserMapper.resetUserPwd(userName, password);
//    }
//
//
//    /**
//     * 通过用户ID删除用户
//     *
//     * @param userId 用户ID
//     * @return 结果
//     */
//    @Override
//    @Transactional
//    public int deleteUserById(Long userId)
//    {
//        return EUserMapper.deleteUserById(userId);
//    }
//
//    /**
//     * 批量删除用户信息
//     *
//     * @param userIds 需要删除的用户ID
//     * @return 结果
//     */
//    @Override
//    @Transactional
//    public int deleteUserByIds(Long[] userIds)
//    {
//        return EUserMapper.deleteUserByIds(userIds);
//    }
//
//    /**
//     * 导入用户数据
//     *
//     * @param userList 用户数据列表
//     * @param isUpdateSupport 是否更新支持，如果已存在，则进行更新数据
//     * @param operName 操作用户
//     * @return 结果
//     */
//    @Override
//    public String importUser(List<EUser> userList, Boolean isUpdateSupport, String operName)
//    {
//        if (StringUtils.isNull(userList) || userList.size() == 0)
//        {
//            throw new ServiceException("导入用户数据不能为空！");
//        }
//        int successNum = 0;
//        int failureNum = 0;
//        StringBuilder successMsg = new StringBuilder();
//        StringBuilder failureMsg = new StringBuilder();
//        String password = configService.selectConfigByKey("sys.user.initPassword");
//        for (EUser user : userList)
//        {
//            try
//            {
//                // 验证是否存在这个用户
//                EUser u = EUserMapper.selectUserByUserName(user.getUserName());
//                if (StringUtils.isNull(u))
//                {
//                    BeanValidators.validateWithException(validator, user);
//                    user.setPassword(SecurityUtils.encryptPassword(password));
//                    user.setCreateBy(operName);
//                    EUserMapper.insertUser(user);
//                    successNum++;
//                    successMsg.append("<br/>" + successNum + "、账号 " + user.getUserName() + " 导入成功");
//                }
//                else if (isUpdateSupport)
//                {
//                    BeanValidators.validateWithException(validator, user);
//                    user.setUserId(u.getUserId());
//                    user.setUpdateBy(operName);
//                    EUserMapper.updateUser(user);
//                    successNum++;
//                    successMsg.append("<br/>" + successNum + "、账号 " + user.getUserName() + " 更新成功");
//                }
//                else
//                {
//                    failureNum++;
//                    failureMsg.append("<br/>" + failureNum + "、账号 " + user.getUserName() + " 已存在");
//                }
//            }
//            catch (Exception e)
//            {
//                failureNum++;
//                String msg = "<br/>" + failureNum + "、账号 " + user.getUserName() + " 导入失败：";
//                failureMsg.append(msg + e.getMessage());
//                log.error(msg, e);
//            }
//        }
//        if (failureNum > 0)
//        {
//            failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
//            throw new ServiceException(failureMsg.toString());
//        }
//        else
//        {
//            successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
//        }
//        return successMsg.toString();
//    }
//
//    /**
//     * 通过手机号查询用户
//     *
//     * @param phone 手机号
//     * @return 用户对象信息
//     */
//    @Override
//    public EUser selectUserByPhone(String phone) {
//        return EUserMapper.selectUserByPhone(phone);
//    }
//
//    /**
//     * 通过用户手机号和appid查询用户
//     *
//     * @param phone 手机号
//     * @return 用户对象信息
//     */
//    @Override
//    public EUser selectUserByPhoneAndAppId(String phone, String appid) {
//        return EUserMapper.selectUserByPhoneAndAppId(phone,appid);
//    }

    /**
     * 通过openid查询用户
     *
     * @param openid 手机号
     * @return 用户对象信息
     */
    @Override
    public RlUser selectUserByWxopenid(String openid) {
        return rlUserMapper.selectUserByWxopenid(openid);
    }

//    /**
//     * 检测用户是否有充值过押金
//     * @param userId
//     */
//    @Override
//    public Boolean checkIsDeposit(Long userId) {
//        EUser eUser = EUserMapper.selectUserById(userId);
//        BigDecimal balance = asUser.getBalance();
////        EtOperatingArea area = etOperatingAreaService.selectEtOperatingAreaByAreaId(asUser.getAreaId());
////        BigDecimal deposit = new BigDecimal(area.getDeposit());
//        if(ObjectUtil.isNull(balance)){
//            log.info("用户【{}】余额为空",userId);
//            return false;
//        }
//        if(balance.compareTo(BigDecimal.ZERO)==0){//余额为0
//            log.info("用户【{}】余额为0",userId);
//            return false;
//        }
//        // 判断是否有押金充值记录
//        EtOrder etOrder = new EtOrder();
//        etOrder.setType(ServiceConstants.ORDER_TYPE_DEPOSIT);
//        etOrder.setUserId(userId);
//        etOrder.setPaid("1");
//        if(etOrderMapper.selectEtOrderList(etOrder).size()<1){//没有充值押金记录
//            log.info("用户【{}】没有充值押金记录",userId);
//            return false;
//        }
//        return true;
//    }

//    /**
//     * 新增用户
//     */
//    @Override
//    public String getNewUser(String powerStart, String powerEnd,String areaId) {
//        if(StringUtils.isNotEmpty(powerStart) && StringUtils.isNotEmpty(powerEnd)){
//            return EUserMapper.getNewUser(powerStart,powerEnd,areaId);
//        }
//        return null;
//    }
//
//    /**
//     * 总用户
//     */
//    @Override
//    public String getTotalUser(String areaId) {
//        return EUserMapper.getTotalUser(areaId);
//    }
//
//    /**
//     * 租赁用户
//     */
//    @Override
//    public String getLeaseUser(String powerStart, String powerEnd,String areaId) {
//        if(StringUtils.isNotEmpty(powerStart) && StringUtils.isNotEmpty(powerEnd)){
//            return EUserMapper.getLeaseUser(powerStart,powerEnd,areaId);
//        }
//        return null;
//    }
//
//    /**
//     * 绑定系统用户
//     */
//    @Transactional
//    @Override
//    public int bandSystemUser(EUser user) {
//        // 删除用户缓存
//        Collection<String> keys = SpringUtils.getBean(RedisCache.class).keys(CacheConstants.APP_LOGIN_TOKEN_KEY + "*");
//        redisCache.deleteObject(keys);
//        return EUserMapper.updateUser(user);
//    }
//
//    /**
//     * 实名认证
//     */
//    @Override
//    public Object authentication(AuthenticationVo authenticationVo) {
//        String idCard = authenticationVo.getIdCard();
//        String realName = authenticationVo.getRealName();
//        Object o = VerifyIdentityUtil.verifyIdentity(verifyUrl, appcode, idCard, realName);
//        return o;
//    }
//
//    /**
//     * 检测是否实名认证
//     */
//    @Override
//    public boolean checkIsAuthentication(Long userId) {
//        if(EUserMapper.selectUserById(userId).getIsAuthentication().equals("1")){
//            return true;
//        }
//        return false;
//    }
//
//    /**
//     * 根据手机号快速搜索用户列表
//     */
//    @Override
//    public List<LabelVo> fastSearch(String phonenumber) {
//        /** 获取设备绑定数量*/
//        List<LabelVo> users = EUserMapper.fastSearch(phonenumber);
//        return users;
//    }
//
//    /**
//     * 更新用户密码
//     */
//    @Override
//    public void updateUserPwd(Long userId, String newPassword) {
//        EUserMapper.updateUserPwd(userId, newPassword);
//    }

}
